/*   mainL.c      main file for Linux and Cygwin                                           */

/*    DESIRE - Direct Executing SImulation in REal time  - for DESIRE/W   */

/*    REGISTERED COPYRIGHT 2008 by Granino A. Korn                          */

/* This source code is copyrighted and distributed under the GNU General
    Public License found in the file GPL.txt in this software package.        **/

/*  amain4reg.c - main DESIRE program for DESIRE/W */ 

/*   added delta, DELTA                                       4/97    */
/*   added keep+, Vector, Mat d/dt, Delta,    
                            add 40 to compiler stack         6/99    */
/*   changed initializers for Linux                       7/25/99 */

/*   new signal handling                                      8/3/01  */
/*   added NEW                                                   4/2/02  */
/*   added Vectr d/dt, Vectr delta, SUBMODEL  9/13/02  */
/*    added MM to slow display rate                   /9/20/02  */  
/*   INITE1, ICOM, IDERIV are now global integer flags
                        and zCOMINT, ztnext are global double   9/18/02  */
/*	 added new func1, func2                              7/25/05	*/ 
/*   global variables, zz command added           11/21/06  */
/*   new version interchanges keep, keep+; list, list+       8/15/07  */
/*   DOS format for DESIRE/W                           8/11/08    */
/*   c++ format, removed "unsigned"                11/20/08   */
                              
/*         - error return to prompt                                    */
/*         - arrays have one extra element to match PASCAL version */
/* ----------------------------------------------------------------------------------- */

#include <string.h>
#include <setjmp.h>
#include <signal.h>
#include <stdlib.h>
#include "declare.h"

/*  --------------------------------------------------------------------
   NOTE: the "relval" array contains:

        relval[i] for i=1 to i=maxnsv    state variables
                          to i=mmm   saved initial t, DT, 2 spares
                          to i=mmm+maxsysp SYSTEM VARIABLES
                          
 		relval[mmm+1]   is MM            
 		relval[mmm+2]   is CHECKN
 		relval[mmm+3]   is DT            
 		relval[mmm+4]   is t (t0 initially)
 		relval[mmm+6]   is ERRMAX
 		relval[mmm+7]   is DTMAX
 		relval[mmm+8]   is DTMIN
 		relval[mmm+9]   is ERMAX
 		relval[mmm+10] is ERMIN
 		relval[mmm+11] is Tevent (currently not used)
 		relval[mmm+12] is iRow
 		relval[mmm+13] is scale
 		relval[mmm+14] is PI
 		relval[mmm+15] is MM                                                                                                                                                             
                          
                          to i=gjj (maxrlvar less stack space)
                              REAL variables as per DESIRE symbol table

        nn1 is no longer in relval
        relval [mmm+ 19 to 23] are n longer usd
       
        relval[0] etc. is unused to correspond to PASCAL version
   ------------------------------------------------------------------ */

int ci,di,gjj;  /** new version for 32 bits. V14W.0, NO hardware registers!! **/
/* ------------------------------------------------------- */

                                                  /* STRING CONSTANTS */

STRING sysp1="NN$CHECKN$DT$TMAX$t$ERRMAX$DTMAX$DTMIN$ERMAX$ERMIN$Tevent$\
iRow$scale$PI$MM$" ;

STRING func1="ln(tim(sin(cos(exp(abs(sqrt(trnc(lim(sgn(ran(atan(round(\
Re(Im(Cabs(Arg(Conjug(expj(log(tan(sinh(cosh(acos(asin(tanh(atan2(\
swtch(SAT(dxXr(sat(deadz(deadc(rect(comp(tri(sigmoid(SIGMOID(sinc(recip(\
func1(func2(" ;

                                                     /* keyword array */

STRING w="else$connect$if$while$repeat$for$until$next$end while$\
end$proceed$STOP$drunr$PROCEDURE$erase$list+$run$data$go to$input$\
save$..$then$FUNCTION$old$load$clear$reset$chain$FFT$to$dump$\
call$time$read$disconnect$delete$drun$list$new$irule$size$\
help$display$STATE$eof$go$note$dimension$edit$auto$ed$bye$\
trace$write$plot$INTEGER$VECTOR$DOT$MATRIX$sh$DYNAMIC$restore$\
PIC$JACOBIAN$label$MACRO$COMPLEX$invoke$..$--$term$d/dt$or$\
dispt$CLEARN$tdelay$store$SAMPLE$get$type$delay$trkhld$stash$OUT$func$\
dispxy$recover$MAT d/dt$step$as input$as output$and$exit$DISPXY$count$\
SEED$ARRAY$UPDATE$LEARN$SHOW$INTP$keep$PLEARN$reload$keep+$erun$rld$NEW$\
zz$delta$DELTA$Vector$Mat d/dt$Delta$func2$vv$Vectr d/dt$Vectr delta$SUBMODEL$"  ; 

/* ------------------------------------------------------------------- */

/* VARIABLE DECLARATIONS */

/* NOTE: these variable names are the same as in older DESIRE programs */

unsigned char cc, cf, bdummy ;      /* cc and cf are spares under UNIX */

unsigned int   lineno, lnumber, no ;                   /* line numbers */
unsigned int   mparea=10, nn2=200, ncol=0 ;  /* auto-incr., start, current */

int   errnum=0, endtxt=linsiz+2, size=1, cstart=1, dispp=1 ;
int   tracer=0, disk=1, append=0, start=0, dynlin=0, nrow=0 ;
int   bye=1 , flag2=0 ;
int   nn1=0 ;                                    /* no. of state vars. */
int   INITE1, ICOM, IDERIV ;
int   gi, gii, gir ;
int   flevel, chanlno ;
int   sbegin, rbegin, hashval, vartyp, xlength ;
int   dmode, dbegin, wptr, datptr, rrr, maxstk ;
int   flag, savindx, INdex, eofflg, notefl ;
int   dflag, sflag, runf, old, flag1, spare1, spare2, spare3 ;
int   stashflag ;
int   spare4, spare5, editflg ;
int   SPARE1, SPARE2, SPARE3, SPARE4 ;

/*** int raddr, rrr, para, iseed, bdummy1, stog0, dim, drunr, eflag ; ***/

int   intval[maxinvar+1] ;
/* ------------------------------------------------------------------- */

double  accum, scale, t0, hdt, zCOMINT, ztnext ;

double  relval[maxrlvar+41] ;    /* REAL variables, and compiler stack */
double  storesv[maxnsv+1] ;                    /* stores inital values */
double  sderiv[maxnsv+1] ;                        /* state derivatives */
double  dpsv[maxnsv+1] ;          /* temporary storage for integration */

ptr  p, q, hashtab[maxhash+1] ;      /* global pointers and hash table */
dsptr  tptr, stktop=NULL ;

double  *bufdisp[15],*bufstash[21], *bufrecvr[21] ;

      /*****> *bufdisp[11] in some versions; fix global.h in that case */
/* ----------------------------------------------------------------------------------- */

void (*COMPILE[maxcomp+1])() ;      /* compiler function pointers */
int   dptr[maxparam+1] ;                /* compiled parameter pointers */
int   jcstart, jdstart ;                                 /* compiler-array indices */
/* ----------------------------------------------------------------------------------- */

FILE *inptr ;                                  /****>   for load, edit */
FILE *outptr ;                                     /****>    for write */
FILE *noteptr ;                                    /* for journal file */
FILE *fdn ;                  /****>    for save, list, list+, type */
FILE *fd[maxchan+1] ;                       /* for write, input */
/* ----------------------------- -------------------------------------- */
                                                    /* STRING BUFFERS */
 char  symbol[varsize+1] ;
 char  pname[maxnam+1] ;
 char  fname[maxnam+1] ;
 char  dlabl[maxcmd+1] ;             /* OS shell command */
 unsigned char  warea[maxtxt+1] ;     /* user text area */
/* -------------------------------------------------------------------- */

jmp_buf djump ;                 /* type declared in setjmp.h */

extern  void derror(int)  ;      extern  void clsall() ;
extern  void initialize() ;   extern  void prepr1() ;
extern  void precomp();       extern  void execute() ;
extern  void scroll() ;
/* ------------------------------------------------------------------- */
     
void keyboard_intr(int sig_num) {

   sigset_t mask_set ;
   sigset_t old_set ;   

   signal(SIGINT,keyboard_intr) ;              reset signal handling 
                                 
   sigfillset(&mask_set) ;         mask signals while inside handler 
   sigprocmask(SIG_SETMASK,&mask_set,&old_set) ;
   
   spare1=1 ;                                            /ctl-c flag 

   sigprocmask(SIG_SETMASK,&old_set,NULL) ;  restore old signal mask 
      }
   
void float_err(int sig_num) {
   signal(SIGFPE,float_err);
   derror(3) ;
   }
  
void bus_intr(int sig_num) { 
   signal(SIGBUS,bus_intr) ;
   derror(11) ; 
   }

void seg_intr(int sig_num) { 
   signal(SIGSEGV,seg_intr) ;
   derror(113) ; 
   }

void abt_intr(int sig_num) { 
   signal(SIGABRT,abt_intr) ;
   derror(113) ; 
   }
/* ------------------------------------------------------------------ */

main(int argc)  {                          /* checks command-line argument */

   initialize() ;   /* symbol table, flags, display, get command line */

   if (argc>1) {                            /* load last user program */

         ncol=10 ; nn2=200 ; append=TRUE ; eofflg=FALSE ;
         if ((inptr=fopen("SYSPIC.lst","r"))==NULL) {
            WRITELN ; 
	    exit(0) ;
            }
         }

   if (setjmp(djump)) goto prompt ;    /* error etc. return to prompt */

  signal(SIGFPE,float_err); **/
   
   signal(SIGINT,keyboard_intr);
   signal(SIGBUS,bus_intr) ;
   signal(SIGSEGV,seg_intr) ;
   signal(SIGABRT,abt_intr) ; 
 
 prompt:

   precomp() ;                               /* main interpreter loop */
   execute() ;
   goto prompt ;
   }

